=== modified file 'rules/annotations/oo_references.rules'
--- old/rules/annotations/oo_references.rules	2022-05-16 16:24:45 +0000
+++ new/rules/annotations/oo_references.rules	2022-05-23 19:34:04 +0000
@@ -43,6 +43,8 @@
 **     CA  20220426 Always wrap the DYNAMIC-PROPERTY's property name and index, when they are literals.
 **                  Fixed a problem when accessing a builtin OO property from a getter/setter.
 **     CA  20220516 Fixed ASSIGN EXTENT(property) = size.
+**     GES 20220501 Rewrote usage of ConvertedClassName to use ClassDefinition instead. This required
+**                  parse time name conversion for the methods we emit for properties.
 */
  -->
  
@@ -108,11 +110,12 @@
    <worker class="com.goldencode.p2j.pattern.FileOperationsWorker"       namespace="fileWorker" />
 
    <!-- variables -->
-   <variable name="nameinfo"  type="com.goldencode.p2j.uast.ConvertedClassName" />
+   <variable name="clsdef"    type="com.goldencode.p2j.uast.ClassDefinition" />
    <variable name="fname"     type="java.lang.String" />
    <variable name="pname"     type="java.lang.String" />
    <variable name="oname"     type="java.lang.String" />
    <variable name="sname"     type="java.lang.String" />
+   <variable name="propkey"   type="java.lang.String" />
    <variable name="javaname"  type="java.lang.String" />
    <variable name="usingPkg"  type="java.lang.String" />
    <variable name="pkgroot"   type="java.lang.String" />
@@ -143,6 +146,10 @@
    <variable name="pidx"      type="java.lang.Long" />
    <variable name="refid"     type="java.lang.Long" />
    <variable name="access"    type="java.lang.Long" />
+   <variable name="isStatic"     type="java.lang.Boolean" />
+   <variable name="isExtent"     type="java.lang.Boolean" />
+   <variable name="accessMode"   type="java.lang.Long" />
+   <variable name="extent"       type="java.lang.Long" />
    <variable name="usingClasses" type="java.util.Set" />
    
    <init-rules>
@@ -247,11 +254,11 @@
                </rule>
                
                <rule on="false">true
-                  <!-- explicit class import -->
+                  <!-- non-Java, explicit class import -->
                   <action>fname = getNoteString("source-file")</action>
-                  <action>nameinfo = loadConvertedClass(fname, false, this)</action>
-                  <rule>nameinfo != null
-                     <action>putNote("legacy-import", nameinfo.getQualifiedName())</action>
+                  <action>clsdef = loadConvertedClass(fname, false, this)</action>
+                  <rule>clsdef != null
+                     <action>putNote("legacy-import", clsdef.getQualifiedJavaName())</action>
                   </rule>
                </rule>
             </rule>
@@ -288,20 +295,20 @@
             isNote("qualified") and isNote("source-file")
 
          <action>fname = getNoteString("source-file")</action>
-         <action>nameinfo = loadConvertedClass(fname, false, this)</action>
+         <action>clsdef = loadConvertedClass(fname, false, this)</action>
          
-         <rule>nameinfo != null
-            <action>oname = nameinfo.getQualifiedName()</action>
+         <rule>clsdef != null
+            <action>oname = clsdef.getQualifiedJavaName()</action>
             <rule>oname.endsWith("_BaseObject_") and parent.type == prog.kw_inherits
                <action>oname = "com.goldencode.p2j.oo.lang.BaseObject"</action>
                <action>sname = "BaseObject"</action>
                
-               <action on="false">sname = nameinfo.getClassName()</action>
+               <action on="false">sname = clsdef.getSimpleJavaName()</action>
             </rule>
 
             <action>putNote("full-java-class", oname)</action>
             <action>putNote("simple-java-class", sname)</action>
-            <action>putNote("containing-package", nameinfo.getPackage())</action>
+            <action>putNote("containing-package", clsdef.getJavaPackage())</action>
             <rule>not usingClasses.contains(oname)
                <action>putNote("qualified-reference", true)</action>
             </rule>
@@ -321,13 +328,13 @@
          <action>copy.parent.putAnnotation("source-file", getNoteString("source-file"))</action>
 
          <action>fname = getNoteString("source-file")</action>
-         <action>nameinfo = loadConvertedClass(fname, false, this)</action>
+         <action>clsdef = loadConvertedClass(fname, false, this)</action>
          
-         <rule>nameinfo != null
-            <action>copy.parent.putAnnotation("full-java-class", nameinfo.getQualifiedName())</action>
-            <action>copy.parent.putAnnotation("simple-java-class", nameinfo.getClassName())</action>
-            <action>copy.parent.putAnnotation("containing-package", nameinfo.getPackage())</action>
-            <rule>not usingClasses.contains(nameinfo.getQualifiedName())
+         <rule>clsdef != null
+            <action>copy.parent.putAnnotation("full-java-class", clsdef.getQualifiedJavaName())</action>
+            <action>copy.parent.putAnnotation("simple-java-class", clsdef.getSimpleJavaName())</action>
+            <action>copy.parent.putAnnotation("containing-package", clsdef.getJavaPackage())</action>
+            <rule>not usingClasses.contains(clsdef.getQualifiedJavaName())
                <action>copy.parent.putAnnotation("qualified-reference", true)</action>
             </rule>
             <action on="false">
@@ -341,13 +348,13 @@
       
       <rule>this.type == prog.enum_value
          <action>fname = getNoteString("source-file")</action>
-         <action>nameinfo = loadConvertedClass(fname, false, this)</action>
+         <action>clsdef = loadConvertedClass(fname, false, this)</action>
          
-         <rule>nameinfo != null
-            <action>copy.putAnnotation("full-java-class", nameinfo.getQualifiedName())</action>
-            <action>copy.putAnnotation("simple-java-class", nameinfo.getClassName())</action>
-            <action>copy.putAnnotation("containing-package", nameinfo.getPackage())</action>
-            <rule>not usingClasses.contains(nameinfo.getQualifiedName())
+         <rule>clsdef != null
+            <action>copy.putAnnotation("full-java-class", clsdef.getQualifiedJavaName())</action>
+            <action>copy.putAnnotation("simple-java-class", clsdef.getSimpleJavaName())</action>
+            <action>copy.putAnnotation("containing-package", clsdef.getJavaPackage())</action>
+            <rule>not usingClasses.contains(clsdef.getQualifiedJavaName())
                <action>copy.putAnnotation("qualified-reference", true)</action>
             </rule>
             <action on="false">
@@ -479,8 +486,8 @@
             
             <rule on="false">true
                <action>fname = getNoteString("found-in-source-file")</action>
-               <action>nameinfo = loadConvertedClass(fname, false, this)</action>
-               <rule>nameinfo != null
+               <action>clsdef = loadConvertedClass(fname, false, this)</action>
+               <rule>clsdef != null
                   <rule>isNote("refid")
                      <!-- use the javaname at the refid, and not what we thing we should convert to -->
                      <action>ref = execLib("get_var", this)</action>
@@ -488,12 +495,15 @@
                         putNote("javaname", #(java.lang.String) ref.getAnnotation("javaname"))
                      </action>
                      
+                     <!-- TODO: it is not clear the exact case which depends upon this code; the previous
+                          code just did a lookup using only the legacy method name (not the signature) so the
+                          getConvertedMethodName() seems like a better approach but we need to watch this -->
                      <rule on="false">!isNote("javaname")
-                        <action>putNote("javaname", nameinfo.getMethod(this.text))</action>
+                        <action>putNote("javaname", clsdef.getConvertedMethodName(this.text, copy))</action>
                      </rule>
                   </rule>
                   
-                  <action>putNote("found-in-full-java-class", nameinfo.getQualifiedName())</action>
+                  <action>putNote("found-in-full-java-class", clsdef.getQualifiedJavaName())</action>
                   <rule>!evalLib("is_java_cls", this)
                      <action>putNote("wrap", true)</action>
                   </rule>
@@ -592,12 +602,12 @@
       <rule>this.type == prog.class_event
          <!-- annotate the event name -->
          <action>fname = getNoteString("found-in-source-file")</action>
-         <action>nameinfo = loadConvertedClass(fname, false, this)</action>
+         <action>clsdef = loadConvertedClass(fname, false, this)</action>
          <action>refid = getNoteLong("refid")</action>
          
          <rule>refid == null
             <action>propref = null</action>
-            <action>printfln("MISSING_REFID for property %s", copy.dumpTree())</action>
+            <action>printfln("MISSING_REFID for event %s", copy.dumpTree())</action>
             
             <action on="false">propref = getAst(refid)</action>
          </rule>
@@ -607,7 +617,12 @@
             <action>javaname = propref.getAnnotation("javaname")</action>
          </rule>
          <rule>javaname == null
-            <action>javaname = nameinfo.getVariable(this.text)</action>
+            <action>isStatic = isNote("static") and getNoteBoolean("static")</action>
+            <rule>isNote("access-mode")
+               <action>accessMode = getNoteLong("access-mode")</action>
+               <action on="false">accessMode = prog.kw_public</action>
+            </rule>
+            <action>javaname = clsdef.lookupVariableJavaName(this.text, accessMode, isStatic)</action>
          </rule>
          
          <action>putNote("javaname", javaname)</action>
@@ -627,14 +642,19 @@
           (copy.parent.type == prog.object_invocation and evalLib("input_argument", copy.parent)))
             
          <action>fname = getNoteString("cls-container")</action>
-         <action>nameinfo = loadConvertedClass(fname, false, this)</action>
+         <action>clsdef = loadConvertedClass(fname, false, this)</action>
          <action>refid = getNoteLong("refid")</action>
+         <action>isExtent = false</action>
          
          <rule>refid == null
             <action>propref = null</action>
-            <action>printfln("MISSING_REFID for property %s", copy.dumpTree())</action>
+            <action>printfln("MISSING_REFID for property %s", copy.dumpTree(true))</action>
+            <action>extent = copy.getAnnotation("extent")</action>
+            <action>isExtent = (extent != null and (extent == -1 or extent &gt; 0))</action>
             
             <action on="false">propref = getAst(refid)</action>
+            <action on="false">extent = propref.getAnnotation("extent")</action>
+            <action on="false">isExtent = (extent != null and (extent == -1 or extent &gt; 0))</action>
          </rule>
          
          <!-- TODO: each of the object_invocation cases below does not consider if the
@@ -653,20 +673,6 @@
             
             <rule>setter == null or setter.id != refid or propref == null
                
-               <!-- normal usage through the setter method -->
-               <rule>propref != null
-                  <action>
-                     javaname = nameinfo.getConvertedMethodName(
-                                  getReferenceNoteString(propref.id, "set-legacysignature"),
-                                  getReferenceNoteString(propref.id, "set-javasignature"))
-                  </action>
-               </rule>
-               <rule>javaname == null
-                  <action>
-                     javaname = nameinfo.getMethodForProperty("set", this.text)
-                  </action>
-               </rule>
-               
                <!-- rewrite the tree -->
                <rule>parent.type == prog.assign
                   <action>attref = copy.parent</action>
@@ -693,6 +699,7 @@
                </rule>
                <action>subref = copy.getImmediateChild(prog.lbracket, null)</action>
                <rule>subref != null
+                  <!-- normal indexed setter for an extent property -->
                   <action>idxref = subref.getChildAt(0)</action>
                   <action>subref.remove()</action>
                   <action>eref = createProgressAst(prog.expression, copy, 1)</action>
@@ -705,6 +712,26 @@
                </rule>
                <action>execLib("rewrite_prop_to_method", copy)</action>
                
+               <rule>!isExtent or subref != null
+                  <!-- normal usage through the setter method (it is not an extent prop or the lvalue
+                       has a subscript which means it is assigning a single element)-->
+                  <action>propkey = "set-javaname"</action>
+                  
+                  <!-- one of the special extent setters -->
+                  <rule on="false">evalLib("is_unsubscripted_extent", childref)
+                     <!-- replace the reference itself -->
+                     <action>propkey = "bulk-set-javaname"</action>
+                     
+                     <!-- assign multi -->
+                     <action on="false">propkey = "set-all-javaname"</action>
+                  </rule>
+               </rule>
+               
+               <rule>propref != null
+                  <action>javaname = propref.getAnnotation(propkey)</action>
+                  <action on="false">javaname = "oo_references.rules_FIXME1"</action>
+               </rule>               
+               
                <!-- direct reference, no rewriting -->
                <action on="false">javaname = setter.getAnnotation("javaname")</action>
                <action on="false">putNote("direct-property-access", true)</action>
@@ -720,16 +747,8 @@
             
             <action>putNote("property-access-type", "length-of")</action>
             <rule>propref != null
-               <action>
-                  javaname = nameinfo.getConvertedMethodName(
-                               getReferenceNoteString(propref.id, "length-of-legacysignature"),
-                               getReferenceNoteString(propref.id, "length-of-javasignature"))
-               </action>
-            </rule>
-            <rule>javaname == null
-               <action>
-                  javaname = nameinfo.getMethodForProperty("length-of", this.text)
-               </action>
+               <action>javaname = propref.getAnnotation("length-of-javaname")</action>
+               <action on="false">javaname = "oo_references.rules_FIXME2"</action>
             </rule>
             
             <!-- rewrite the tree -->
@@ -751,24 +770,15 @@
          
          <!-- EXTENT(property) = size (indeterminate extent resize) -->
          <rule>
-            (upPath("STATEMENT/ASSIGN/KW_EXTENT/OBJECT_INVOCATION")           and parent.indexPos == 0) or
-            (upPath("STATEMENT/KW_ASSIGN/ASSIGN/KW_EXTENT/OBJECT_INVOCATION") and parent.indexPos == 0) or
-            (upPath("STATEMENT/ASSIGN/KW_EXTENT")                             and copy.indexPos == 0)   or
-            (upPath("STATEMENT/KW_ASSIGN/ASSIGN/KW_EXTENT")                   and copy.indexPos == 0)
+            (upPath("STATEMENT/ASSIGN/KW_EXTENT/OBJECT_INVOCATION")           and parent.parent.indexPos == 0) or
+            (upPath("STATEMENT/KW_ASSIGN/ASSIGN/KW_EXTENT/OBJECT_INVOCATION") and parent.parent.indexPos == 0) or
+            (upPath("STATEMENT/ASSIGN/KW_EXTENT")                             and parent.indexPos == 0)        or
+            (upPath("STATEMENT/KW_ASSIGN/ASSIGN/KW_EXTENT")                   and parent.indexPos == 0)
             
             <action>putNote("property-access-type", "resize")</action>
             <rule>propref != null
-               <action>
-                  javaname = nameinfo.getConvertedMethodName(
-                               getReferenceNoteString(propref.id, "resize-legacysignature"),
-                               getReferenceNoteString(propref.id, "resize-javasignature"))
-               </action>
-            </rule>
-
-            <rule>javaname == null
-               <action>
-                  javaname = nameinfo.getMethodForProperty("resize", this.text)
-               </action>
+               <action>javaname = propref.getAnnotation("resize-javaname")</action>
+               <action on="false">javaname = "oo_references.rules_FIXME3"</action>
             </rule>
             
             <!-- rewrite the tree -->
@@ -797,23 +807,8 @@
          <!-- getter -->
          <rule>javaname == null
             <action>putNote("property-access-type", "getter")</action>
-         
+            
             <rule>getter == null or getter.id != refid or propref == null
-               
-               <!-- normal usage through the getter method -->
-               <rule>propref != null
-                  <action>
-                     javaname = nameinfo.getConvertedMethodName(
-                                  getReferenceNoteString(propref.id, "get-legacysignature"),
-                                  getReferenceNoteString(propref.id, "get-javasignature"))
-                  </action>
-               </rule>
-               
-               <rule>javaname == null
-                  <action>
-                     javaname = nameinfo.getMethodForProperty("get", this.text)
-                  </action>
-               </rule>
 
                <!-- rewrite the tree -->
                <action>subref = copy.getImmediateChild(prog.lbracket, null)</action>
@@ -825,6 +820,20 @@
                <action>execLib("rewrite_prop_to_method", copy)</action>
                <action>putNote("wrap", true)</action>
                
+               <rule>!isExtent or subref != null
+                  <!-- normal usage through the getter method (scalar/non-extent or return a single
+                       element) -->
+                  <action>propkey = "get-javaname"</action>
+                  
+                  <!-- the special extent getter that obtains the reference to the array -->
+                  <action on="false">propkey = "bulk-get-javaname"</action>
+               </rule>
+               
+               <rule>propref != null
+                  <action>javaname = propref.getAnnotation(propkey)</action>
+                  <action on="false">javaname = "oo_references.rules_FIXME4"</action>
+               </rule>
+               
                <!-- direct reference -->
                <action on="false">javaname = getter.getAnnotation("javaname")</action>
                <action on="false">putNote("direct-property-access", true)</action>
@@ -834,8 +843,9 @@
          <rule>javaname != null
             <action>putNote("javaname", javaname)</action>
             <action on="false">
-               printfln("WARNING: non-local property javaname lookup failure! %s",
-                        copy.dumpTree())
+               printfln("WARNING: non-local property javaname (%s) lookup failure! %s",
+                        propkey,
+                        copy.dumpTree(true))
             </action>
          </rule>
          
@@ -847,17 +857,8 @@
                
                <!-- save the setter name, so assignment_style_stmt_rewriting can use it -->
                <rule>propref != null
-                  <action>
-                     javaname = nameinfo.getConvertedMethodName(
-                                  getReferenceNoteString(propref.id, "set-legacysignature"),
-                                  getReferenceNoteString(propref.id, "set-javasignature"))
-                  </action>
-               </rule>
-               
-               <rule>javaname == null
-                  <action>
-                     javaname = nameinfo.getMethodForProperty("set", this.text)
-                  </action>
+                  <action>javaname = propref.getAnnotation("set-javaname")</action>
+                  <action on="false">javaname = "oo_references.rules_FIXME5"</action>
                </rule>
 
                <!-- direct reference -->
@@ -887,13 +888,21 @@
             !(isNote("cls-property") or getNoteBoolean("cls-property"))
             
          <action>fname = getNoteString("found-in-source-file")</action>
-         <action>nameinfo = loadConvertedClass(fname, false, this)</action>
+         <action>clsdef = loadConvertedClass(fname, false, this)</action>
          
          <!-- member vars -->
          <rule>!isNote("refid") and (!isNote("cls-property") or !getNoteBoolean("cls-property"))
-            <action>putNote("javaname", nameinfo.getVariable(this.text))</action>
-            <rule>nameinfo.getVariableExtent(this.text) != null
-               <action>putNote("extent", nameinfo.getVariableExtent(this.text))</action>
+            <action>isStatic = isNote("static") and getNoteBoolean("static")</action>
+            <rule>isNote("access-mode")
+               <action>accessMode = getNoteLong("access-mode")</action>
+               <action on="false">accessMode = prog.kw_public</action>
+            </rule>
+            <action>
+               putNote("javaname", clsdef.lookupVariableJavaName(this.text, accessMode, isStatic))
+            </action>
+            <action>extent = clsdef.lookupVariableExtent(this.text, accessMode, isStatic)</action>
+            <rule>extent != 0
+               <action>putNote("extent", extent)</action>
             </rule>
             
             <rule on="false">isNote("refid")
@@ -904,7 +913,7 @@
             </rule>
          </rule>
          
-         <action>putNote("found-in-full-java-class", nameinfo.getQualifiedName())</action>
+         <action>putNote("found-in-full-java-class", clsdef.getQualifiedJavaName())</action>
       </rule>
    </walk-rules>
    

=== modified file 'rules/annotations/output_parameters.rules'
--- old/rules/annotations/output_parameters.rules	2022-05-14 17:02:52 +0000
+++ new/rules/annotations/output_parameters.rules	2022-05-20 11:57:12 +0000
@@ -128,6 +128,8 @@
    <variable name="idx"            type="java.lang.Integer" />
    <variable name="ptype"          type="java.lang.Integer" />
    <variable name="refid"          type="java.lang.Long" />
+   <variable name="deftype"        type="java.lang.String" />
+   <variable name="calltype"       type="java.lang.String" />
    <variable name="assign_back"    type="java.lang.Boolean" />
    <variable name="needs_value"    type="java.lang.Boolean" />
    
@@ -274,6 +276,7 @@
             </rule>
          </rule>
          
+         <!-- lref will only be non-null for extent cases -->
          <rule>lref != null and 
                (lref.type == prog.kw_in_out or 
                 lref.type == prog.kw_output or 
@@ -282,23 +285,41 @@
             <action>putNote("extent", #(long) ref.getAnnotation("extent"))</action>
             <action>ref.putAnnotation("force_extent_mutable", true)</action>
             
+            <action>calltype = null</action>
+            
             <rule>!evalLib("fieldtype", type)
                <rule>isNote("full-java-class")
                   <action>
-                     putNote("outputExtentType", 
-                             sprintf("object&lt;? extends %s&gt;", 
-                                     ref.getAnnotation("full-java-class")))
+                     deftype = sprintf("object&lt;? extends %s&gt;", ref.getAnnotation("full-java-class"))
                   </action>
 
-                  <action on="false">
-                     putNote("outputExtentType", #(java.lang.String) ref.getAnnotation("classname"))
-                  </action>
+                  <!-- override type to match definition signature -->
+                  <rule on="false">isNote("classname")
+                     <action>deftype = getNoteString("classname")</action>
+                     <action>calltype = getNoteString("calltype")</action>
+                     <action on="false">deftype = #(java.lang.String) ref.getAnnotation("classname")</action>
+                     <action on="false">calltype = #(java.lang.String) ref.getAnnotation("calltype")</action>
+                  </rule>
                </rule>
                
-               <action on="false">
-                  putNote("outputExtentType", 
-                          #(java.lang.String) execLib("wrapper_name_for_field_type", type))
-               </action>
+               <rule on="false">ref.isAnnotation("classname")
+                  <!-- override type to match definition signature -->
+                  <action>
+                     deftype = #(java.lang.String) ref.getAnnotation("classname")
+                  </action>
+                  <action on="false">
+                     calltype = #(java.lang.String) ref.getAnnotation("calltype")
+                  </action>
+                  
+                  <!-- use the field type -->
+                  <action on="false">
+                     deftype = #(java.lang.String) execLib("wrapper_name_for_field_type", type)
+                  </action>
+               </rule>
+            </rule>
+            <action>putNote("outputExtentType", deftype)</action>
+            <rule>calltype != null
+               <action>putNote("calltype", calltype)</action>
             </rule>
 
             <rule>lref.id != this.id

=== modified file 'rules/annotations/record_scoping_prep.rules'
--- old/rules/annotations/record_scoping_prep.rules	2022-05-16 12:34:34 +0000
+++ new/rules/annotations/record_scoping_prep.rules	2022-05-20 12:08:20 +0000
@@ -6,7 +6,7 @@
 **
 ** Copyright (c) 2005-2022, Golden Code Development Corporation.
 **
-** _#_ _I_ __Date__ __JPRM__ ___________________________________Description___________________________________
+** _#_ _I_ __Date__ __JPRM__ __________________________________Description__________________________________
 ** 001 GES 20050919   @22810 Preparation for record scoping analysis. In
 **                           particular, all database references are
 **                           classified into the type (weak, strong,
@@ -112,11 +112,12 @@
 **     CA  20220225          A 'DEFINE BUFFER book FOR book' statement (where the buffer name is the same as 
 **                           the table name) inside an internal top-level block will be dropped if there is a
 **                           reference for this buffer, appearing somewhere before this statement.
-*     CA  20220425           Refactored to eliminate the dependency on '-1' reference ID for resolving a  
+**     CA  20220425           Refactored to eliminate the dependency on '-1' reference ID for resolving a  
 **                           buffer's reference scope - the default buffer will be referenced instead, and a 
 **                           special annotation possible_needs_buffer will be used to track the previous 
 **                           requirements of '-1' refid.
-**    CA  20220516           'b4temporary' is a boolean, not string, annotation.
+**     CA  20220516          'b4temporary' is a boolean, not string, annotation.
+**     GES 20210506          Use TableParameter subclasses when needed.
 */
 -->
 
@@ -199,6 +200,7 @@
    <variable name="extra"            type="java.lang.String" />
    <variable name="pextra"           type="java.lang.String" />
    <variable name="bufRefKey"        type="java.lang.String" />
+   <variable name="tabParmType"      type="java.lang.String" />
    <variable name="ref"              type="com.goldencode.ast.Aast" />
    <variable name="master"           type="com.goldencode.p2j.convert.BufferList" />
    <variable name="ref2"             type="com.goldencode.ast.Aast" />
@@ -287,7 +289,20 @@
                   
                   <!-- lookup and store the DMO class/package names -->
                   <rule>bref.parent.type == prog.kw_table
-                     <action>bref.putAnnotation("bufclassname", "TableParameter")</action>
+                  
+                     <!-- lookup the TableParameter subclass that should be used, default to the base class
+                          if no jtype annotation exists -->
+                     <action>
+                        tabParmType = #(java.lang.String) execLib("read_jtype",
+                                                                  bref.parent,
+                                                                  "TableParameter",
+                                                                  "record_scoping_prep")
+                     </action>
+                  
+                     <!-- record the proper TableParameter or TableParameter subclass -->
+                     <action>
+                        bref.putAnnotation("bufclassname", tabParmType)
+                     </action>
                      
                      <rule>bref.type == prog.buffer
                         <action>refid = lookupDictionaryLong("buf_ids", bufName)</action>

